<template>
  <div
    :class="`${color}--text`"
    :style="{
      'font-size': `${size}px !important`,
      'font-weight': `${weight} !important`,
      display: block ? 'block' : 'contents',
      'letter-spacing': typeof spacing === 'number' ? `${spacing}px` : spacing
    }"
  >
    <slot></slot>
  </div>
</template>

<script lang="ts">
import { Vue, Component, Prop } from "vue-property-decorator";

@Component({})
export default class DText extends Vue {
  @Prop({ type: String, required: false, default: "regular" })
  public readonly weight!: string;

  @Prop({ type: Number, required: false, default: 10 })
  public readonly size!: number;

  @Prop({ type: String, required: false, default: "muted" })
  public readonly color!: string;

  @Prop({ type: Boolean, required: false, default: true })
  public readonly block!: boolean;

  @Prop({ type: [Number, String], required: false, default: "normal" })
  public readonly spacing!: number | string;
}
</script>

<style></style>
